//IntSet.h

#include <vector>
using std::vector;

class IntSet {
	std::vector<int> set;

public:
	// constructors
	IntSet(void);
	IntSet(const IntSet&);
	IntSet(vector<int>::const_iterator, vector<int>::const_iterator);
	
	//essential modification/infomation methods
	int size() const;			// #
	void add(int v);			// #
	bool remove(int v);			// #
	bool contains(int v);		// #
	bool empty(void) const;		// #	
	
	///
	///ITERATOR
	///
	
	typedef vector<int>::iterator iterator;
	typedef vector<int>::const_iterator const_iterator;
	
	iterator(const iterator&);  //copy constructor
	
	iterator begin() { return set.begin(); }
	const_iterator begin() const { return set.begin(); }
	iterator end() { return set.end(); }
	const_iterator end() const { return set.end(); }
	
	bool operator==(const &iterator);
	bool operator!=(const &iterator);

	///
	///END ITERATOR
	///
	
	IntSet operator*();
	bool operator!=(IntSet&);
	bool operator==(IntSet&);

	IntSet operator+(const IntSet&);
	IntSet operator*(const IntSet&);
	IntSet operator-(const IntSet&);
	
	/*//begin binary operators
	IntSet operator<=
	IntSet operator<
	IntSet operator>=
	IntSet operator>
	IntSet operator==
	IntSet operator!=
	
	//begin unary operators
	IntSet operator=
	IntSet operator+=
	IntSet operator*=
	IntSet operator-=*/
};
